/*
 Copyright (C) 2010-2017 by Hoefer Alfred

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version. 

 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details. 

 You should have received a copy of the GNU General Public
 License along with this program; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA

 ----------------------------------------------------------------
 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "PIC33pgm.h"
#include "cicons.h"
#include "tpixmap.h"
#include "cpu_pgm_ds33E.h"




const int build_v = ALD_BUILD_V;
const char *build_date = __DATE__;


int step, chk_programmer;
int pnlVal_idx;
dword SendFlag;
dword rs232Sleep;
bool rs232run;

TSysInfo0 CPU_Info0;
dword LastCPU_Factory, LastCPU_Type;
static char ini_Gruppe[32];

/*______________________ TPanelValue ____________________________________*/
static void CpuIniWR() {
  int i;
  char *pc;
  TFormMain *mf;
  TPanelValue *pnlVal;
  char buf[40 * MAX_PNLVAL];

	if (!ini_Gruppe[0]) return;

	mf = appDat.obj;
	pc = buf;
	for (i=0;i<MAX_PNLVAL;i++) {
	    pnlVal = mf->pnlVal[i];
	    ppcmove(&pc, GetCaption_pc((TWins*)pnlVal->cobValTyp));
	    *pc = ' '; pc++;
	    if (pnlVal->cobSizeTyp->SelItem) {
		hexto0xppc(&pc, pnlVal->cobSizeTyp->SelItem->tag, 5);
	    } else {
		ppcmove(&pc, "0x0004");
	    }
	    *pc = ' '; pc++;
	    ppcmove(&pc, GetCaption_pc((TWins*)pnlVal->edAddr));
	    *pc = ' '; pc++;
	}
	*pc = 0;
	TpcIni_WR(appDat.appIni, ini_Gruppe, "pVal", buf);
	TpcIni_Save(appDat.appIni);
}

static dword TPanelValue_GetDataLen(TPanelValue *self) {
	if (!self->cobSizeTyp->SelItem) return 0;
	return self->cobSizeTyp->SelItem->tag & 0x00ff;
}

static void TPanelValue_AzVal(TPanelValue *self) {
  int lg, max, AzType;
  byte *pb;
  int16_t *pint16;
  int32_t *pint32;
  word *pw;
  dword *pdw;
  float *pf;
  char *pc;
  char buf[PNLVAL_MAX_DATA * 3];

	AzType = PNLVAL_AZ_BYTE;
	if (self->cobSizeTyp->SelItem) 
		AzType = self->cobSizeTyp->SelItem->tag & PNLVAL_AZ_MASK;
	pc = buf;
	lg = self->RdDataCount;
	max = TPanelValue_GetDataLen(self);
	if (lg > max) lg = max;
	if (lg > 0) {
	    switch (AzType) {
	    case PNLVAL_AZ_BYTE:
		pb = self->RdData;
		for (;lg>0;lg--) {
		    hextoppc(&pc, *pb, 2 | kSPACE_ADD);
		    pb++;
		}
		break;

	    case PNLVAL_AZ_WORD:
		lg = (lg + 1) >> 1;
		pw = (word*)self->RdData;
		for (;lg>0;lg--) {
		    hextoppc(&pc, *pw, 4 | kSPACE_ADD);
		    pw++;
		}
		break;

	    case PNLVAL_AZ_DWORD:
		lg = (lg + 3) >> 2;
		pdw = (dword*)self->RdData;
		for (;lg>0;lg--) {
		    hextoppc(&pc, *pdw, 8 | kSPACE_ADD);
		    pdw++;
		}
		break;

	    case PNLVAL_AZ_INT16:
		lg = (lg + 1) >> 1;
		pint16 = (int16_t*)self->RdData;
		for (;lg>0;lg--) {
		    ppcmove_v32(&pc, *pint16, kVALUE_int | kSPACE_ADD);
		    pint16++;
		}
		break;

	    case PNLVAL_AZ_INT32:
		lg = (lg + 3) >> 2;
		pint32 = (int32_t*)self->RdData;
		for (;lg>0;lg--) {
		    ppcmove_v32(&pc, *pint32, kVALUE_int | kSPACE_ADD);
		    pint32++;
		}
		break;

	    case PNLVAL_AZ_FLOAT:
		lg = (lg + 3) >> 2;
		pf = (float*)self->RdData;
		for (;lg>0;lg--) {
		    floattoppc(&pc, *pf, 3 | kSPACE_ADD);
		    pf++;
		}
		break;
	    }
	}
	if ((pc > buf) && (pc[-1] == ' ')) pc--;
	*pc = 0;
	SetCaption((TWins*)self->edData, buf);
}

static void cobSizeTyp_OnClick(TMenu *self, long KeyState, TMenuItem *mi) {
  TPanelValue *pnlVal;

	pnlVal = GetParentWins_wtyp((TWins*)self, wtyp_TPanelValue);
	if (pnlVal) {
	    TPanelValue_AzVal(pnlVal);
	    if (pnlVal->miLastSizeTyp != mi) {
		pnlVal->miLastSizeTyp = mi;
		CpuIniWR();
	    }
	}
}

static void buRD_OnClick(TButton *self, long KeyState, bool DblClick) {
  TPanelValue *pnlVal;
  dword Addr;

	pnlVal = GetParentWins((TWins*)self);
	pnlVal->Flag |= PNLVAL_SENDRD;
	Addr = pctoint(GetCaption_pc((TWins*)pnlVal->edAddr));
	if (pnlVal->LastAddr != Addr) {
	    pnlVal->LastAddr = Addr;
	    CpuIniWR();
	}
}

static void buWR_OnClick(TButton *self, long KeyState, bool DblClick) {
  TPanelValue *pnlVal;
  dword Addr;

	pnlVal = GetParentWins((TWins*)self);
	pnlVal->Flag |= PNLVAL_SENDWR;
	Addr = pctoint(GetCaption_pc((TWins*)pnlVal->edAddr));
	if (pnlVal->LastAddr != Addr) {
	    pnlVal->LastAddr = Addr;
	    CpuIniWR();
	}
}


static void SetCpuCaption(TFormMain *mf) {
  char *pc;
  char buf[32];

	if (pcncmp(ini_Gruppe, "Programmer", 10)) {
	    SetCaption(mf->pnlCpuType, ini_Gruppe);
	    SetColor(mf->pnlCpuType, 0xE0C0C0);
	} else {
	    hextopc(buf, CPU_Info0.CPU_Ver, 4);
	    pc = pcadd_n(3, ini_Gruppe, " V=0x", buf);
	    
	    mf = appDat.obj;
	    SetCaption(mf->pnlCpuType, pc);
	    xfree(pc);
	    SetColor(mf->pnlCpuType, 0xC0E0C0);
	}
}

static void CpuIniRD() {
  int i, val;
  char *pc, *token;
  const char *cpc;
  TFormMain *mf;
  TPanelValue *pnlVal;
  TMenuItem *mi;
  word PIC33dev[2];
  const TPicDevice *PicDevice;
  bool ok_33;

	mf = appDat.obj;

	ok_33 = false;
	ini_Gruppe[0] = 0;
	if (CPU_Info0.CPU_Factory == FACTORY_MICROCHIP) {
	    PIC33dev[0] = CPU_Info0.CPU_Type;
	    PIC33dev[1] = CPU_Info0.CPU_Ver;
	    PicDevice = GetDevice_Rev(PIC33dev, FL_33E, NULL);
	    if (!PicDevice) PicDevice = GetDevice_Rev(PIC33dev, FL_33F, NULL);
	    if (PicDevice) {
		pcmove(ini_Gruppe, PicDevice->name);
		if (mf->BridgeModus && mf->BridgeModusMk) {
		    if (PicDevice->Flags & FL_33F) {
			mf->mi_ds33F->fu |= miChecked;
			mf->mi_ds33E->fu &= ~miChecked;
			ok_33 = true;
		    } else if (PicDevice->Flags & FL_33E) {
			mf->mi_ds33E->fu |= miChecked;
			mf->mi_ds33F->fu &= ~miChecked;
			ok_33 = true;
		    }
		} else if (mf->IsProgrammer) {
		    pcmove(ini_Gruppe, "Programmer PICpgm2");
		}
	    }
	}
	if (ok_33) {
	    set_pg_pgm_dev(mf);
	    mf->mi_ds33F->fu |= miNotEnabled;
	    mf->mi_ds33E->fu |= miNotEnabled;
	} else {
	    mf->mi_ds33F->fu &= ~miNotEnabled;
	    mf->mi_ds33E->fu &= ~miNotEnabled;
	}

	if (!ini_Gruppe[0]) {
	    pc = ini_Gruppe;
	    hextoppc(&pc, CPU_Info0.CPU_Factory, 2);
	    *pc = '.'; pc++;
	    hextoppc(&pc, CPU_Info0.CPU_Type, 4);
	}
// printf("%s(%d): CPU=%s\n", FL, ini_Gruppe);

	if ((LastCPU_Factory == CPU_Info0.CPU_Factory) &&
	    (LastCPU_Type == CPU_Info0.CPU_Type)) {
	    SetCpuCaption(mf);
	    return;
	}
	LastCPU_Factory = CPU_Info0.CPU_Factory;
	LastCPU_Type = CPU_Info0.CPU_Type;


	SetCpuCaption(mf);
	cpc = TpcIni_RD(appDat.appIni, ini_Gruppe, "pVal");
	if (cpc) {
	    i = 0;
	    while (cpc && (i < MAX_PNLVAL)) {
		pnlVal = mf->pnlVal[i];
		i++;

		cpc = GetToken(cpc, &token);
		if (!token) break;
		mi = pnlVal->cobValTyp->popup->MenuItem;
		while (mi && !pccasecmp(mi->s, token)) mi = mi->next;
		if (mi) {
		    pnlVal->miLastValTyp = mi;
		    TComboBox_SetItem_mi(pnlVal->cobValTyp, mi);
		}
		xfree(token);

		cpc = GetToken(cpc, &token);
		if (!token) break;
		val = pctoint(token);
		xfree(token);
		mi = pnlVal->cobSizeTyp->popup->MenuItem;
		while (mi && (mi->tag != val)) mi = mi->next;
		if (mi) {
		    pnlVal->miLastSizeTyp = mi;
		    TComboBox_SetItem_mi(pnlVal->cobSizeTyp, mi);
		}

		cpc = GetToken(cpc, &token);
		if (!token) break;
		SetCaption((TWins*)pnlVal->edAddr, token);
		xfree(token);
	    }
	}
}


/*______________________ TPanelValue Create  ____________________________*/
static void TPanelValue_CreateParams(TWins_Create_struct *wcs) {
  TPanelValue *self = wcs->wins;

	self->height = 26;
	self->BorderFu = mBorder | mBorderNoLeft | mBorderNoRigth;
	self->Align = alTop;
}

static TPanelValue *TPanelValue_Create(TWins *Parent) {
  TWins_Create_struct wcs;
  TPanelValue *self;

	TWins_Create_struct_init(&wcs, sizeof(TPanelValue), wtyp_TPanelValue);
	wcs.Parent = Parent;
	wcs.CreateParams = TPanelValue_CreateParams;
	TWins_DefaultConf(&wcs);
	self = wcs.wins;

	self->cobValTyp = TComboBox_CreateS((TWins*)self, 0, 3, 78, 20, "Abs");
	self->cobValTyp->ReadOnly = true;
	self->cobSizeTyp = TComboBox_CreateS((TWins*)self, 80, 3, 68, 20, NULL);
	self->cobSizeTyp->ReadOnly = true;

	self->edAddr = TEdit_CreateS((TWins*)self, 150, 3, 78, 20, "0x0000");
	self->edData = TEdit_CreateS((TWins*)self, 230, 3, 178, 20, NULL);
	self->buRD = TButton_CreateS((TWins*)self, 410, 2, 28, 22, "RD");
	self->buRD->OnClick = buRD_OnClick;
	self->buWR = TButton_CreateS((TWins*)self, 440, 2, 28, 22, "WR");
	self->buWR->OnClick = buWR_OnClick;
	self->cbRDrep = TChkBox_CreateS((TWins*)self, 470, 3, 38, 20, "rep");

	TComboBox_AddItem(self->cobSizeTyp, "1 Byte",  0, 
			cobSizeTyp_OnClick)->tag = 1 | PNLVAL_AZ_BYTE;
	TComboBox_AddItem(self->cobSizeTyp, "-",  0, NULL);

	TComboBox_AddItem(self->cobSizeTyp, "2 Byte",  0, 
			cobSizeTyp_OnClick)->tag = 2 | PNLVAL_AZ_BYTE;
	TComboBox_AddItem(self->cobSizeTyp, "1 Word",  0, 
			cobSizeTyp_OnClick)->tag = 2 | PNLVAL_AZ_WORD;
	TComboBox_AddItem(self->cobSizeTyp, "1 Int16", 0, 
			cobSizeTyp_OnClick)->tag = 2 | PNLVAL_AZ_INT16;
	TComboBox_AddItem(self->cobSizeTyp, "-",  0, NULL);

	TComboBox_AddItem(self->cobSizeTyp, "4 Byte",  miAdd_setSel, 
			cobSizeTyp_OnClick)->tag = 4 | PNLVAL_AZ_BYTE;
	TComboBox_AddItem(self->cobSizeTyp, "2 Word",  0, 
			cobSizeTyp_OnClick)->tag = 4 | PNLVAL_AZ_WORD;
	TComboBox_AddItem(self->cobSizeTyp, "2 Int16", 0, 
			cobSizeTyp_OnClick)->tag = 4 | PNLVAL_AZ_INT16;
	TComboBox_AddItem(self->cobSizeTyp, "1 DWord", 0, 
			cobSizeTyp_OnClick)->tag = 4 | PNLVAL_AZ_DWORD;
	TComboBox_AddItem(self->cobSizeTyp, "1 Int32", 0, 
			cobSizeTyp_OnClick)->tag = 4 | PNLVAL_AZ_INT32;
	TComboBox_AddItem(self->cobSizeTyp, "1 Float32",  0, 
			cobSizeTyp_OnClick)->tag = 4 | PNLVAL_AZ_FLOAT;
	TComboBox_AddItem(self->cobSizeTyp, "-",  0, NULL);

	TComboBox_AddItem(self->cobSizeTyp, "8 Byte",  0, 
			cobSizeTyp_OnClick)->tag = 8 | PNLVAL_AZ_BYTE;
	TComboBox_AddItem(self->cobSizeTyp, "4 Word",  0, 
			cobSizeTyp_OnClick)->tag = 8 | PNLVAL_AZ_WORD;
	TComboBox_AddItem(self->cobSizeTyp, "4 Int16", 0, 
			cobSizeTyp_OnClick)->tag = 8 | PNLVAL_AZ_INT16;
	TComboBox_AddItem(self->cobSizeTyp, "2 DWord", 0, 
			cobSizeTyp_OnClick)->tag = 8 | PNLVAL_AZ_DWORD;
	TComboBox_AddItem(self->cobSizeTyp, "2 Int32", 0, 
			cobSizeTyp_OnClick)->tag = 8 | PNLVAL_AZ_INT32;
	TComboBox_AddItem(self->cobSizeTyp, "2 Float32",  0, 
			cobSizeTyp_OnClick)->tag = 8 | PNLVAL_AZ_FLOAT;

	Set_Parent((TWins*)self, Parent);
	return self;
}

/*______________________ rs232ald _______________________________________*/
static dword GetHexVal(const char **ppcpc, int MaxChr) {
  const char *cpc;
  dword result;

	cpc = *ppcpc;
	result = 0;
	while (zC_HEX[(byte)*cpc] && (MaxChr > 0)) {
	    result = (result << 4) | zC_ASCII2INT[(byte)*cpc];
	    cpc++;
	}
	while (*cpc == ' ') cpc++;
	*ppcpc = cpc;
	return result;
}

static bool TPanelValue_SetRD232Bef(TPanelValue *self, bool send) {
  int lx, AzType;
  dword addr, len;
  TFormMain *mf;
  const char *cpc;
  byte *pb;
  word *pw;
  dword *pdw;
  float *pf;
  byte TxDbuf[32];

	if (!self) return false;
	if (!self->cobSizeTyp->SelItem) {
err01:
	    self->Flag = 0;
	    TChkBox_SetChecked(self->cbRDrep, false);
	    return false;
	}

	mf = appDat.obj;
	if (self->Flag & PNLVAL_SENDWR) {
	    cpc = GetCaption_pc((TWins*)self->edData);
	    if (cpc) while (*cpc && (*cpc == 0x20)) cpc++;
	    if (cpc) {
		if (!send) return true;
		len = TPanelValue_GetDataLen(self);
		if (!len) goto err01;
		if (!self->cobSizeTyp->SelItem) goto err01;

		SendFlag = PNLVAL_SENDWR;
		self->Flag &= ~PNLVAL_SENDWR;
// printf("%s l=%d = ", GetCaption_pc((TWins*)self->edAddr), len);
		addr = pctoint(GetCaption_pc((TWins*)self->edAddr));
		pdw = (dword*)TxDbuf;
		*pdw = addr;

		if (len > sizeof(TxDbuf)) len = sizeof(TxDbuf);
		AzType = self->cobSizeTyp->SelItem->tag & PNLVAL_AZ_MASK;

		lx = 4;
		switch (AzType) {
		case PNLVAL_AZ_BYTE:
		    pb = TxDbuf + 4;
		    while (zC_HEX[(byte)*cpc] && len) {
			*pb = GetHexVal(&cpc, 2);
			pb++; lx++; len--;
		    }
		    break;

		case PNLVAL_AZ_WORD:
		    pw = (word*)(TxDbuf + 4);
		    while (zC_HEX[(byte)*cpc] && (len > 0)) {
			*pw = GetHexVal(&cpc, 4);
			pw++; lx += 2; len -= 2;
		    }
		    break;

		case PNLVAL_AZ_DWORD:
		    pdw = (dword*)(TxDbuf + 4);
		    while (zC_HEX[(byte)*cpc] && (len > 0)) {
			*pdw = GetHexVal(&cpc, 8);
			pdw++; lx += 4; len -= 4;
		    }
		    break;

		case PNLVAL_AZ_INT16:
		    pw = (word*)(TxDbuf + 4);
		    while (cpc && (len > 0)) {
			*pw = ppctoint_scan(&cpc, true);
			pw++; lx += 2; len -= 2;
		    }
		    break;

		case PNLVAL_AZ_INT32:
		    pdw = (dword*)(TxDbuf + 4);
		    while (cpc && (len > 0)) {
			*pdw = ppctoint_scan(&cpc, true);
			pdw++; lx += 4; len -= 4;
		    }
		    break;

		case PNLVAL_AZ_FLOAT:
		    pf = (float*)(TxDbuf + 4);
		    while (cpc && (len > 0)) {
			*pf = ppctofloat_scan(&cpc, true);
			pf++; lx += 4; len -= 4;
		    }
		    break;
		}

// printf("\n");
		Fill0(self->RdData, PNLVAL_MAX_DATA);
		self->RdDataCount = lx - 4;
		pnmove(self->RdData, TxDbuf + 4, self->RdDataCount);

		rs232ald_SendData(mf->rs232, RSBEF_WRITE_DATA, TxDbuf, lx);
		rs232run = true;
		step = STEP_PNLVAL;
		return true;

	    } else {
		self->Flag &= ~PNLVAL_SENDWR;
	    }
	}

	if ((self->Flag & PNLVAL_SENDRD) || self->cbRDrep->Checked) {
// printf("%s(%d): 0x%04x\n", FL, self->Flag);

	    len = TPanelValue_GetDataLen(self);
	    if (!len) goto err01;
	    if (!send) return true;

	    SendFlag = PNLVAL_SENDRD;
	    self->Flag &= ~PNLVAL_SENDRD;
	    addr = pctoint(GetCaption_pc((TWins*)self->edAddr));
//	    *(dword*)TxDbuf = addr;
	    pdw = (dword*)TxDbuf;
	    *pdw = addr;
	    if (TxDbuf[3]) {
		TxDbuf[4] = len;
		if (!rs232ald_SendData(mf->rs232, RSBEF_READ_DATA, TxDbuf, 5)) goto err01;
	    } else {
		TxDbuf[3] = len;
		if (!rs232ald_SendData(mf->rs232, RSBEF_READ_DATA, TxDbuf, 4)) goto err01;
	    }
	    rs232run = true;
	    step = STEP_PNLVAL;
	    return true;

//	} else {
	}
	return false;
}


static void Send_BridgeModus(TFormMain *mf, bool BridgeModus) {
  const char *cpc;

	mf->BridgeModus = BridgeModus;
	mf->BridgeModusMk = BridgeModus;

	if (BridgeModus) {
 printf("%s(%d): Send_BridgeModus ON\n", FL);
	    cpc = "\x00\xf2";
	    mf->miRS232Bridge->fu |= miChecked;
	} else {
 printf("%s(%d): Send_BridgeModus OFF\n", FL);
	    cpc = "\x00\xf3";
	    mf->miRS232Bridge->fu &= ~miChecked;
	}
	rs232ald_SendData(mf->rs232, RSBEF_BRIDGE_MODE, (const byte*)cpc, 2);
}

static bool Chk_pnlVal(TFormMain *mf, bool send) {
  int i;
  TPanelValue *pnlVal;

	pnlVal = mf->pnlVal[pnlVal_idx];
	for (i=MAX_PNLVAL;i>0;i--) {
	    pnlVal_idx++;
	    if (pnlVal_idx >= MAX_PNLVAL) pnlVal_idx = 0;
	    pnlVal = mf->pnlVal[pnlVal_idx];
	    if (TPanelValue_SetRD232Bef(pnlVal, send)) return true;
	}
	return false;
}

static void OnRS232Timer(TgTimer *gTimer) {
  TFormMain *mf;
  char *pc;
  char buf[24];

	mf = appDat.obj;
	if (!rs232run && !rs232Sleep) {
	    if (run_pg_ext(mf)) {
		step = STEP_PGM;
		rs232run = true;

#if USE_I2C_BRIDGE
	    } else if (start_pg_i2c(mf)) {
		step = STEP_I2C;
		rs232run = true;
#endif

	    } else if (run_pg_crt(mf)) {
		step = STEP_CRT;
		rs232run = true;

	    } else if (mf->BridgeModusMk != mf->BridgeModus) {
		Send_BridgeModus(mf, mf->BridgeModus);
		step = STEP_BRIDGE;

	    } else {
		Chk_pnlVal(mf, true);
	    }
	}



	if (rs232Sleep) {
	    rs232Sleep--;
	    if (!rs232Sleep) {
		step = STEP_SYNC;
		rs232ald_SendData(mf->rs232, RSBEF_SYNC, NULL, 0);
	    }
	}

	if (mf->TimeSec != appDat.app_tv.tv_sec) {
	    pc = buf;
	    inttoppc(&pc, mf->rs232->GesTxD_Byte + mf->rs232->GesRxD_Byte);
	    pcmove(pc, " B/s");
	    SetCaption(mf->pnlIOByte, buf);

	    mf->TimeSec = appDat.app_tv.tv_sec;
	    mf->rs232->GesTxD_Byte = 0;
	    mf->rs232->GesRxD_Byte = 0;
	}
}
void rs232ald_ErrPrint(dword orig_bef, dword bef, const byte *data, size_t lg) {
  const char *msg;

	if (bef == RSBEF_ERROR) {
	    msg = NULL;
	    switch (*data) {
	    case RSERR_CRC:		msg = "ERR_CRC"; break;
	    case RSERR_BUFLEN:		msg = "ERR_BUFLEN"; break;
	    case RSERR_UNKNOWN_BEF:	msg = "ERR_UNKNOWN_BEF"; break;
	    case RSERR_BEF_SIZE:	msg = "ERR_BEF_SIZE"; break;
	    case RSERR_ADDR_FAULT:	msg = "ERR_ADDR_FAULT"; break;
	    case RSERR_LEN_OVERFLOW:	msg = "ERR_LEN_OVERFLOW"; break;
	    case RSERR_READ_ONLY:	msg = "ERR_READ_ONLY"; break;
	    }
	    if (msg) {
	        printf("ERROR: %s  orig.bef=0x%02x\n", msg, orig_bef);
	    } else {
	        printf("ERROR: UNKNOWN ERROR  orig.bef=0x%02x <> ret=0x%02x\n", orig_bef, bef);
	    }
	} else {
	    printf("ERROR: orig.bef=0x%02x <> ret=0x%02x\n", orig_bef, bef);
	}
}

static void OnRxDData(Trs232ald *self, dword bef, const byte *data, size_t lg) {
  int TxDstep;
  TFormMain *mf;
  TPanelValue *pnlVal;
  bool mk;

// printf("%s(%d): 0x%02x  lg=%d  0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x\n", FL, bef, lg, data[0], data[1], data[2], data[3], data[4], data[5]);

	mf = appDat.obj;
	SetColor(mf->pnlErr, 0xc0ffc0);
	TxDstep = -1;
	if (step == STEP_SYNC) {
// printf("%s(%d): STEP_SYNC %d\n", FL, mf->HasChkProgrammer);
	    if (mf->HasChkProgrammer) {
		TxDstep = STEP_INFO_0;
	    } else {
		TxDstep = STEP_CHKPROG;
	    }

	} else if (step == STEP_CHKPROG) {
// printf("%s(%d): STEP_CHKPROG \n", FL);
	    mf->HasChkProgrammer = true;
	    TxDstep = STEP_SYNC;
	    set_en_pg_pgm(mf, true);
#if USE_I2C_BRIDGE
	    set_en_pg_i2c(mf, true);
#endif
	    set_en_pg_crt(mf, true);

	} else if (step == STEP_INFO_0) {
// printf("%s(%d): STEP_INFO_0 \n", FL);
	    if (bef == RSBEF_GET_INFO) {
		if (((lg == sizeof(TSysInfo0))-2) || (lg == sizeof(TSysInfo0))) {
		    pnmove(&CPU_Info0, data, sizeof(TSysInfo0));
		    if (lg == (sizeof(TSysInfo0)-2)) CPU_Info0.Extra = 0;
// printf("%s(%d): STEP_INFO_0 lg=%d %d\n", FL, lg, CPU_Info0.Extra);
		    if (!mf->BridgeModus && 
			(CPU_Info0.HW_Type == HW_TYPE_PROGRAMMER) &&
			!mf->IsProgrammer) {
			mf->IsProgrammer = true;
			if (mf->BridgeAuto) {
			    step = STEP_BRIDGE;
			    Send_BridgeModus(mf, true);
			    return;
			}
		    }

		    CpuIniRD();
		    set_pg_crt(&CPU_Info0);
// printf("%s(%d): 0x%02x 0x%04x 0x%04x\n", FL, CPU_Info0.CPU_Factory, CPU_Info0.CPU_Type, CPU_Info0.DataArt);
		} else {
		    appError(EMSG_ERR1, "TSysInfo0 size %d <> len %d", sizeof(TSysInfo0), lg);
		}
	    } else {
		rs232ald_ErrPrint(self->LastTxDBef, bef, data, lg);
	    }


	    TxDstep = STEP_PNLVAL;

	} else if (step == STEP_PNLVAL) {
	    if (SendFlag & PNLVAL_SENDRD) {
		if (bef == RSBEF_READ_DATA) {
//	printf("%s(%d): %d\n", FL, pnlVal_idx);
		    pnlVal = mf->pnlVal[pnlVal_idx];
		    if (pnlVal) {
			Fill0(pnlVal->RdData, PNLVAL_MAX_DATA);
			pnlVal->RdDataCount = lg;
			if (pnlVal->RdDataCount > PNLVAL_MAX_DATA) 
				pnlVal->RdDataCount = PNLVAL_MAX_DATA;
			pnmove(pnlVal->RdData, data, pnlVal->RdDataCount);
			TPanelValue_AzVal(pnlVal);
		    }
TxD_pnlVal:
		    mk = false;
		    while (!mk && ((pnlVal_idx + 1) < MAX_PNLVAL)) {
			pnlVal_idx++;
			mk = TPanelValue_SetRD232Bef(mf->pnlVal[pnlVal_idx], false);
		    }
		    if (mk) {
			TxDstep = STEP_PNLVAL;
		    }
		} else {
		    rs232ald_ErrPrint(RSBEF_READ_DATA, bef, data, lg);
		}

	    } else if (SendFlag & PNLVAL_SENDWR) {
		if (bef == RSBEF_OK) {
		    if (!TPanelValue_SetRD232Bef(mf->pnlVal[pnlVal_idx], false)) goto TxD_pnlVal;
		    TxDstep = STEP_PNLVAL;

		} else {
		    rs232ald_ErrPrint(self->LastTxDBef, bef, data, lg);
		}
	    }
	} else if (step == STEP_PGM) {
	    if (OnRxDData_pg_ext(self, bef, data, lg)) {
		TxDstep = STEP_PGM;
	    } else {
		rs232Sleep = 10;  //500ms
	    }

#if USE_I2C_BRIDGE
	} else if (step == STEP_I2C) {
	    if (OnRxDData_pg_i2c(self, bef, data, lg)) {
		TxDstep = STEP_I2C;
	    }
#endif

	} else if (step == STEP_CRT) {
	    if (OnRxDData_pg_crt(self, bef, data, lg)) {
		TxDstep = STEP_CRT;
	    } /* else if (Chk_pnlVal(mf, false)) {
		TxDstep = STEP_PNLVAL;
	    } */

	} else if (step == STEP_BRIDGE) {
// printf("%s(%d): RxD STEP_BRIDGE 0x%02x\n", FL, bef);
	    if (bef != RSBEF_OK) {
		mf->BridgeModus = false;
		mf->BridgeModusMk = false;
		mf->miRS232Bridge->fu &= ~miChecked;
	    }
	    TxDstep = STEP_SYNC;

	}
	SendFlag = 0;


	if (TxDstep == STEP_SYNC) {
// printf("%s(%d): TxD STEP_SYNC\n", FL);
	    step = STEP_SYNC;
	    rs232ald_SendData(mf->rs232, RSBEF_SYNC, NULL, 0);

	} else if (TxDstep == STEP_CHKPROG) {
	    Send_BridgeModus(mf, false);
	    step = STEP_CHKPROG;

	} else if (TxDstep == STEP_INFO_0) {
	    step = STEP_INFO_0;
	    rs232ald_SendData(self, RSBEF_GET_INFO, (const byte*)"\0", 1);

	} else if (TxDstep == STEP_PNLVAL) {
	    if (!TPanelValue_SetRD232Bef(mf->pnlVal[pnlVal_idx], true)) {
		rs232run = false;
	    }

	} else if (TxDstep == STEP_PGM) {

	} else if (TxDstep == STEP_I2C) {

	} else if (TxDstep == STEP_CRT) {

	} else {
	    rs232run = false;
	}
}

static void SetErrorCaption(TFormMain *self) { 
  char *pc;
  char buf[40];

	pc = buf;
	ppcmove(&pc, "Err=");
	inttoppc(&pc, self->ErrTimeOut);
	*pc = '/'; pc++;
	inttoppc(&pc, self->ErrTimeOutRep);
	*pc = '/'; pc++;
	inttoppc(&pc, self->ErrCrc);
	SetCaption(self->pnlErr, buf);
}

static void Close_rs232(TFormMain *self) {
	set_en_pg_pgm(self, false);
#if USE_I2C_BRIDGE
	set_en_pg_i2c(self, false);
#endif
	set_en_pg_crt(self, false);
	self->miRS232Open->fu &= ~miChecked;
	ppTfree(&self->rs232Timer);
	rs232_close((Trs232*)self->rs232);
	SetCaption(self->pnlIOByte, "0 B/s");
	self->HasChkProgrammer = false;
	self->IsProgrammer = false;
	self->BridgeModus = false;
	self->BridgeModusMk = false;
	self->miRS232Bridge->fu &= ~miChecked;
}

static bool rs232_OnERROR(Trs232ald *self, int rs232Err, ic32 *nc) {
  TFormMain *mf;

	mf = appDat.obj;

	switch (rs232Err) {
	case rs232ERR_RxD_OVERRUN:
	    appError(EMSG_ERR1, "rs232 RxD Overrun");
	    break;

	case rs232ERR_DEVICE_CLOSE:
	    Close_rs232(mf);
	    return false;

	case rs232ERR_TIMEOUT_REP:
	    mf->ErrTimeOutRep++;
	    appError(EMSG_WARN, "rs232 RxD TimeOut count=%d", self->TxDRepCount);
	    break;

	case rs232ERR_TIMEOUT:
	    mf->ErrTimeOut++;
	    if (mf->BridgeModus) {
		MsgBox_Error((TWins*)mf, "Bridge mode off\n\nSlave RS232 not run");
		step = STEP_BRIDGE;
		Send_BridgeModus(mf, false);
	    } else {
		if (!mf->HasChkProgrammer) {
		    step = STEP_SYNC;
		    Send_BridgeModus(mf, false);
		} else {
		    step = STEP_SYNC;
		    rs232ald_SendData(mf->rs232, RSBEF_SYNC, NULL, 0);
		}
	    }
	    SetColor(mf->pnlErr, 0xff8080);
	    break;

	case rs232ERR_RxD_CRC_REP:
	case rs232ERR_TxD_CRC_REP:
	    mf->ErrCrc++;
	    break;

	case rs232ERR_RxD_CRC:
	case rs232ERR_TxD_CRC:
	    mf->ErrTimeOut++;
	    mf->ErrCrc++;
	    break;

	default:
	    appError(EMSG_ERR1, "rs232 ErrorNr=%d", rs232Err);
	}
	SetErrorCaption(mf);
	return true;
}

Trs232ald *Get_rs232() {
  Trs232ald *rs232;
	rs232 = ((TFormMain*)appDat.obj)->rs232;
	if (!Trs232_IsOpen((Trs232*)rs232)) rs232 = NULL;
	return rs232;
}

/*_______________________________________________________________________*/

/*static void TFormMain_OnResize(TFormMain *self) {
} */

static void TFormMain_OnMove(TFormMain *self) {
	TpcIni_WR_int(appDat.appIni, APPNAME, "Top", self->top);
	TpcIni_WR_int(appDat.appIni, APPNAME, "Left", self->left);
	TpcIni_Save(appDat.appIni);
}

static void mHelp_Info(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormMain *mf = (TFormMain*)self->FormStruct;
  char buf[80];

	snprintf(buf, sizeof(buf), APPNAME" %s   (build-%d  %s)", 
			ALD_VERSION, build_v, build_date);
	Copyright_MsgBox_Show((TWins*)mf, buf);
}

static void menuSetting_OnMenuOpen(TMenu *self) {
  TFormMain *mf;
  bool en;

	mf = (TFormMain*)self->FormStruct;
	en = (mf->miRS232Open->fu & miChecked) == 0;
	SetEnabled((TWins*)mf->menuSetDev, en);
	SetEnabled((TWins*)mf->menuSetBaud, en);
}

static void mSetting_rs232Open(TMenu *self, long KeyState, TMenuItem *smi) {
  dword PortNr, BaudRate;
  TFormMain *mf;
  TMenuItem *mi;


	mf = (TFormMain*)self->FormStruct;
	SetColor(mf->pnlErr, 0xC0C0C0);
	mf->mi_ds33F->fu &= ~miNotEnabled;
	mf->mi_ds33E->fu &= ~miNotEnabled;

	SetCaption(mf->pnlCpuType, " ---");
	SetColor(mf->pnlCpuType, 0xC0C0C0);

	if (smi->fu & miChecked) {
	    Close_rs232(mf);

	} else {
	    mf->ErrTimeOut = 0;
	    mf->ErrTimeOutRep = 0;
	    mf->ErrCrc = 0;
	    SetErrorCaption(mf);
	    mf->TimeSec = appDat.app_tv.tv_sec;
	    mf->rs232->GesTxD_Byte = 0;
	    mf->rs232->GesRxD_Byte = 0;
	    set_en_pg_pgm(mf, false);
#if USE_I2C_BRIDGE
	    set_en_pg_i2c(mf, false);
#endif
	    set_en_pg_crt(mf, false);

	    PortNr = 0;
	    BaudRate = 0;
	    mi = mf->menuSetDev->MenuItem;
	    while (mi) {
		if (mi->fu & miChecked) {PortNr = mi->tag - 1; break;}
		mi = mi->next;
	    }
	    mi = mf->menuSetBaud->MenuItem;
	    while (mi) {
		if (mi->fu & miChecked) {BaudRate = mi->tag; break;}
		mi = mi->next;
	    }

	    step = STEP_SYNC;
#ifndef _OS_WIN32
	    if (PortNr & PORT_USB_ACM) {
		mf->rs232->DevBaseName = "/dev/ttyACM";
	    } else {
		mf->rs232->DevBaseName = "/dev/ttyS";
	    }
#endif

	    if (rs232_open((Trs232*)mf->rs232, PortNr & PORTNR_MASK, BaudRate, rsWLEN8) &&
		rs232ald_SendData(mf->rs232, RSBEF_SYNC, NULL, 0)) 
	    {
	        mf->rs232Timer = gTimerX_Add(Timer_Enabled, 50, OnRS232Timer);
		smi->fu |= miChecked;
		pnlVal_idx = 0;
		rs232run = true;
	    }
	}
}

static void mSetting_rs232BridgeModus(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormMain *mf;

	mf = (TFormMain*)self->FormStruct;

	mf->BridgeModus = (smi->fu & miChecked) != 0;
}

static void mSetting_rs232BridgeAuto(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormMain *mf;

	mf = (TFormMain*)self->FormStruct;

	mf->BridgeAuto = (smi->fu & miChecked) != 0;
	TpcIni_WR_boolean(appDat.appIni, APPNAME, "BridgeAuto", mf->BridgeAuto);
	TpcIni_Save(appDat.appIni);
}

static void mSetting_dsPIC33(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormMain *mf;
  const char *cpc;

	mf = appDat.obj;
	mf->mi_ds33E->fu &= ~miChecked;
	mf->mi_ds33F->fu &= ~miChecked;
	cpc = NULL;
	if (smi == mf->mi_ds33E) {
	    mf->mi_ds33E->fu |= miChecked;
	    cpc = "dsPIC33E";
	}
	if (smi == mf->mi_ds33F) {
	    mf->mi_ds33F->fu |= miChecked;
	    cpc = "dsPIC33F";
	}
	set_pg_pgm_dev(mf);


	TpcIni_WR(appDat.appIni, "PGM", "Dev", cpc);
	TpcIni_Save(appDat.appIni);
}

static void mSetDev(TMenu *self, long KeyState, TMenuItem *smi) {
  TMenuItem *mi;

	mi = self->MenuItem;
	while (mi) {
	    mi->fu &= ~miChecked;
	    if (mi == smi) mi->fu |= miChecked;
	    mi = mi->next;
	}
}

static void mSetBaud(TMenu *self, long KeyState, TMenuItem *smi) {
  TMenuItem *mi;

	mi = self->MenuItem;
	while (mi) {
	    mi->fu &= ~miChecked;
	    if (mi == smi) mi->fu |= miChecked;
	    mi = mi->next;
	}
}

static void menuSetDev_OnMenuOpen(TMenu *self) {
#ifndef _OS_WIN32
  TMenuItem *mi;
  char *pc;
  char buf[32];

	mi = self->MenuItem;
	while (mi) {
	    if (mi->tag & PORT_USB_ACM) {
		pc = buf;
		ppcmove(&pc, "/dev/ttyACM");
		inttopc(pc, (mi->tag & PORTNR_MASK) - 1);
		mi->fu |= miNotVisible;
		if (file_chk_exist(buf, findCHR)) {
		    mi->fu &= ~miNotVisible;
		}
	    }
	    mi = mi->next;
	}
#endif
}
/*
static void mFile_Exit(TMenu *self, long KeyState, TMenuItem *smi) {
  Close();
}
*/
/* ------------------------------------------------------------------- */
#ifndef _OS_WIN32
static char zico16PICpgm2_16x16[] = {
 0x04,0x08,0x10,0x00,0x10,0x00,0x00,0x00,0x6A,0x00,0x85,0x21,0x85,0x22,0xE6,0x39,
 0x07,0x43,0x8B,0x5B,0x8D,0x73,0x92,0x94,0x1C,0xE7,0x61,0xB3,0x77,0xCD,0x3E,0xEC,
 0x3C,0xB8,0x85,0x88,0xC5,0x3B,0x2E,0x25,0x00,0x25,0x15,0xF1,0x8C,0x59,0x0A,0x61,
 0x23,0x16,0x23,0xCB,0x69,0x11,0x12,0x02,0x84,0x73,0xE1,0x8F,0x98,0x31,0x9B,0x04,
 0x09,0xD0,0x24,0x40,0x9A,0x84,0x09,0xC8,0x84,0xD6,0x06,0x35,0x4B,0x88,0xCB,0xC4,
 0x86,0x72,0x98,0x74,0x23,0x9B,0x46,0x53,0x54,0x5C,0xA6,0x46,0xA3,0xB2,0x61,0xD8,
 0xA8,0x6A,0x83,0x90,0x6C,0x6F,0x02,0x68,0x03,0x03};
#endif

static const char *Help_Msg = {
  "\n"
  "Usage: "APPNAME"\n"
  "\n"
  "  -h, --help           Prints out this screen\n\n"
  "  ALDccp: "APPNAME" version "ALD_VERSION"  (build %d  %s)\n"
};

int main (int argc, char **argv) {
  int i;
  char *val;
  const char *cpc;
  TFormMain *self;
  TMenuItem *mi;
  bool help = False;
  bool err = False;

	i = 1;
	while (!err && (i < argc)) {
	    val = argv[i];
	    if (*val == '-') {
		val++;
		switch (*val) {
		case 'h':
		    help = True;
		    break;
		case '-':
		    val++;
		    if (pcncmp(val, "help", 4)) {
			help = True;
#ifdef Test_Root_WinId
		    } else if (pcncmp(val, "TestRootWinID", 13)) {
			i++;
			val = argv[i];
			if (val && *val != '-') {
				TestRootWinId = pctoint(val);
			} else err = True;
#endif
		    } else err = True;
		    break;
		default: 
		    err = True;
		}
	    }
	    i++;
	}

	if (help || err) {
	    printf(Help_Msg, build_v, build_date);
	    exit(err);
	}

	initXapp(0, argc, argv);

	ThImageWR_Reg(1, &hImageWR_png);

#ifdef USE_DECOR
	appXDat.DefaultButtonDecor = TDecor_button_w3b3_Create();
//	appXDat.DefaultWinsDecor = TDecor_w3b3_Create(&TDecoBuR3B3_up_Tab, &TDecoBuR3B3_down_Tab);
#endif
	appDat.inifile_app = pcadd(appDat.ALDini_dir, "/"APPNAME".ini");
	appDat.appIni = TpcIni_Create(appDat.inifile_app);

	self = TForm_CreatParamAlg(NULL, sizeof(TFormMain));
#ifndef _OS_WIN32
	self->Icon = GetDeskIcon(ddkt_Application, 16, APPNAME, 
				    gdifu_noZoom, zico16PICpgm2_16x16);
#endif
//	self->FormZStyle = fzsOnTop | fszNoTitle | fszNoBorder | fszNoInput;
	self->FormPosition = poDesigned;
	self->left   = TpcIni_RD_int(appDat.appIni, APPNAME, "Left", 0);
	self->top    = TpcIni_RD_int(appDat.appIni, APPNAME, "Top", 0);
	self->width  = 510;
	self->height = 300;
	self->min_width = 500;
	self->min_height = 300;
//	self->OnResize = TFormMain_OnResize;
	self->OnMove = TFormMain_OnMove;
	appDat.obj = self;
	SetCaption((TWins*)self, APPNAME);

	self->pnlTop = TWins_CreateBA((TWins*)self, 0, 0, 200, 21, mBorder | mBorderL, alTop);

// ******* Menu File *******
	MenuFile_Create(self);
// ******* Menu Setting *******
	self->mbSetting = TMenuButton_Create(self->pnlTop, self->mbFile);
	SetCaption((TWins*)self->mbSetting, "Settings");
	Set_Parent((TWins*)self->mbSetting, self->pnlTop);

	self->menuSetting = TMenu_Create((TWins*)self);
	self->menuSetDev  = TMenu_Create((TWins*)self);
	self->menuSetDev->OnMenuOpen = menuSetDev_OnMenuOpen;
	self->menuSetBaud = TMenu_Create((TWins*)self);

	self->menuSetting->OnMenuOpen = menuSetting_OnMenuOpen;
	self->mbSetting->menu = self->menuSetting;
	self->miRS232Open = TMenu_AddItem(self->menuSetting, "rs232 Open", 
					miCanCheck, mSetting_rs232Open);
	mi = TMenu_AddItem(self->menuSetting, "rs232 PortNr", 0, NULL);
	mi->next_menu = self->menuSetDev;
	mi = TMenu_AddItem(self->menuSetting, "rs232 BaudRate", 0, NULL);
	mi->next_menu = self->menuSetBaud;
//----------------
	TMenu_AddItem(self->menuSetting, "-", 0, NULL);

	self->BridgeAuto = TpcIni_RD_boolean(appDat.appIni, APPNAME, "BridgeAuto", false);

	self->miRS232BridgeAuto = TMenu_AddItem(self->menuSetting, "RS232 Bridge Auto", 
					miAutoToggle, mSetting_rs232BridgeAuto);
	if (self->BridgeAuto) self->miRS232BridgeAuto->fu |= miChecked;

	self->miRS232Bridge = TMenu_AddItem(self->menuSetting, "Bridge modus", 
					miAutoToggle, mSetting_rs232BridgeModus);
//----------------
	TMenu_AddItem(self->menuSetting, "-", 0, NULL);
	self->mi_ds33E = TMenu_AddItem(self->menuSetting, "dsPIC33E", 
					miCanCheck, mSetting_dsPIC33);
	self->mi_ds33F = TMenu_AddItem(self->menuSetting, "dsPIC33F", 
					miCanCheck, mSetting_dsPIC33);

	cpc = TpcIni_RD(appDat.appIni, "PGM", "Dev");
	if (pccasecmp(cpc, "dsPIC33F")) {
	    self->mi_ds33F->fu |= miChecked;
	} else {
	    self->mi_ds33E->fu |= miChecked;
	}

//----------------
	TMenu_AddItem(self->menuSetDev, "Com 1", miChecked|miCanCheck, mSetDev)->tag = 1;
	TMenu_AddItem(self->menuSetDev, "Com 2", miCanCheck, mSetDev)->tag = 2;
	TMenu_AddItem(self->menuSetDev, "Com 3", miCanCheck, mSetDev)->tag = 3;
	TMenu_AddItem(self->menuSetDev, "Com 4", miCanCheck, mSetDev)->tag = 4;
#ifdef _OS_WIN32
	TMenu_AddItem(self->menuSetDev, "Com 5", miCanCheck, mSetDev)->tag = 5;
	TMenu_AddItem(self->menuSetDev, "Com 6", miCanCheck, mSetDev)->tag = 6;
	TMenu_AddItem(self->menuSetDev, "Com 7", miCanCheck, mSetDev)->tag = 7;
	TMenu_AddItem(self->menuSetDev, "Com 8", miCanCheck, mSetDev)->tag = 8;
#else /* _OS_WIN32 */
	TMenu_AddItem(self->menuSetDev, "Com 5 USB", miCanCheck, mSetDev)->tag = 1 | PORT_USB_ACM;
	TMenu_AddItem(self->menuSetDev, "Com 6 USB", miCanCheck, mSetDev)->tag = 2 | PORT_USB_ACM;
	TMenu_AddItem(self->menuSetDev, "Com 7 USB", miCanCheck, mSetDev)->tag = 3 | PORT_USB_ACM;
	TMenu_AddItem(self->menuSetDev, "Com 8 USB", miCanCheck, mSetDev)->tag = 4 | PORT_USB_ACM;
#endif
	TMenu_AddItem(self->menuSetBaud,   "9600", miCanCheck, mSetBaud)->tag = 9600;
	TMenu_AddItem(self->menuSetBaud,  "19200", miCanCheck, mSetBaud)->tag = 19200;
	TMenu_AddItem(self->menuSetBaud,  "38400", miCanCheck, mSetBaud)->tag = 38400;
	TMenu_AddItem(self->menuSetBaud,  "57600", miCanCheck, mSetBaud)->tag = 57600;
	TMenu_AddItem(self->menuSetBaud, "115200", miChecked|miCanCheck, mSetBaud)->tag = 115200;

// ******* Menu Help *******
	self->mbHelp = TMenuButton_Create(self->pnlTop, self->mbFile);
	SetCaption((TWins*)self->mbHelp, "Help");
	Set_Parent((TWins*)self->mbHelp, self->pnlTop);

	self->menuHelp = TMenu_Create((TWins*)self);
	self->mbHelp->menu = self->menuHelp;

	mi = TMenu_AddItem(self->menuHelp, "Info", 0, mHelp_Info);
	mi->pic = get_pic16_info(False);


	self->pgc = TPageControl_CreateA((TWins*)self);
	SetBorder((TWins*)self->pgc, mBorder | mBorderL);
	self->pg_pgm  = TPageControl_AddNewPage(self->pgc, "pgm");
	self->pg_dump = TPageControl_AddNewPage(self->pgc, "dump");
#if USE_I2C_BRIDGE
	self->pg_i2c  = TPageControl_AddNewPage(self->pgc, "I2C");
//	self->pg_i2c->Enabled = false;
#endif
	self->pg_crt  = TPageControl_AddNewPage(self->pgc, "crt");

	for (i=0;i<MAX_PNLVAL;i++) {
	    self->pnlVal[i] = TPanelValue_Create((TWins*)self->pg_dump);
	}

//	self->pnlMiddle = TWins_CreateBA((TWins*)self, 0, 0, 200, 42, mBorder | mBorderL, alClient);
	init_pg_pgm(self->pg_pgm);



	self->pnlBottom = TWins_CreateBA((TWins*)self, 0, 0, 200, 21, 0, alBottom);

	self->pnlErr = TWins_CreateB(self->pnlBottom, 0, 2, 99, 19, mBorder|mBorderL);
	self->pnlErr->CaptionFu = mCaptionPaint|mCaptionLeft;
	SetCaption(self->pnlErr, "Err=0/0/0");

	self->pnlIOByte = TWins_CreateB(self->pnlBottom, 100, 2, 99, 19, mBorder|mBorderL);
	self->pnlIOByte->CaptionFu = mCaptionPaint|mCaptionLeft;
	SetCaption(self->pnlIOByte, "0 B/s");

	self->pnlCpuType = TWins_CreateB(self->pnlBottom, 200, 2, 200, 19, mBorder|mBorderL);
	self->pnlCpuType->CaptionFu = mCaptionPaint|mCaptionLeft;
	SetCaption(self->pnlCpuType, " ---");

#if USE_I2C_BRIDGE
	init_pg_i2c(self->pg_i2c);
#endif
	init_pg_crt(self->pg_crt);


	appError_ev = default_Error_ev;

	self->rs232 = Trs232ald_Create();
	self->rs232->OnRxDData = OnRxDData;
	self->rs232->OnERROR = rs232_OnERROR;

//	TFormPgm_Create(self);

//	Set_Focus((TWins*)self->buOk);

	AppRun();
	return 0;
}
