/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef	__DSPIC_DEVICE_H__
#define	__DSPIC_DEVICE_H__    1
typedef struct {
  const word rev;
  const word nr;
} TPicDeviceRev;

#define FL_TEST_OK	1
#define FL_33F		0x10
#define FL_33E		0x20
#define FL_33F_OK	(FL_33F | FL_TEST_OK)
#define FL_33E_OK	(FL_33E | FL_TEST_OK)

#define MAX_REV		8

typedef struct TPicDevice {
  const char name[20];
  const dword id;
  const dword Flags;	//FL_TEST_OK,...
  const dword dwnc;
  const TPicDeviceRev rev[MAX_REV];
  const dword EEprom;
  const dword Ram_kb;
  const dword MaxFlash;
  const dword MaxCfg;
  const word WriteBlocks;
  const word EraseBlocks;
  const byte ConfReg[12];
} TPicDevice;


extern void LsChips(dword Flags);
extern const TPicDevice *GetDevice(const word *data, dword Flags, bool PrintData);
extern const TPicDevice *GetDevice_Rev(const word *data, dword Flags, int *rev_idx);


#endif /* __DSPIC_DEVICE_H__ */
