/*
 Copyright (C) 2010-2017 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/


#include "PIC33pgm.h"
#include "tpixmap.h"
#include "cicons.h"

static void menuFile_OnMenuOpen(TMenu *self) {
  TFormMain *mf;

	mf = appDat.obj;
#if USE_I2C_BRIDGE
	if (mf->pgc->AktPage == mf->pg_i2c) {
	    mf->miLoad->fu &= ~miNotEnabled;
	    mf->miSaveAs->fu &= ~miNotEnabled;
	} else {
	    mf->miLoad->fu |= miNotEnabled;
	    mf->miSaveAs->fu |= miNotEnabled;
	}
#endif
	if (save_as_pg_crt_ok(mf)) {
	    mf->miLcdSaveAs->fu &= ~miNotEnabled;
	} else {
	    mf->miLcdSaveAs->fu |= miNotEnabled;
	}
}

#if USE_I2C_BRIDGE
static void mFile_Open(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormMain *mf;

	mf = appDat.obj;
	if (!mf->File_Dlg) mf->File_Dlg = Create_File_Dlg((TWins*)mf);

	if (mf->pgc->AktPage == mf->pg_i2c) {
	    pg_i2c_LoadFile(mf);
	}
}

static void mFile_SaveAs(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormMain *mf;

	mf = appDat.obj;
	if (!mf->FileSave_Dlg) mf->FileSave_Dlg = Create_FileSave_Dlg((TWins*)mf);

	if (mf->pgc->AktPage == mf->pg_i2c) {
	    pg_i2c_SaveFile(mf);
	}
}
#endif

static void mFile_LcdSaveAs(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormMain *mf;

	mf = appDat.obj;
	if (!mf->FileSaveLCD_Dlg) mf->FileSaveLCD_Dlg = Create_FileSave_Dlg((TWins*)mf);
	pg_crt_SaveFile(mf);
}

static void mFile_Exit(TMenu *self, long KeyState, TMenuItem *smi) {
  Close();
}
/* ______________________ Create _____________________________________ */
void MenuFile_Create(TFormMain *self) {
  TMenuItem *mi;

	self->mbFile = TMenuButton_Create(self->pnlTop, (TMenuButton*)self);
	self->mbFile->top = 2;
	self->mbFile->left = 1;
	SetCaption((TWins*)self->mbFile, "File");
	Set_Parent((TWins*)self->mbFile, self->pnlTop);

	self->menuFile = TMenu_Create((TWins*)self);
	self->menuFile->OnMenuOpen = menuFile_OnMenuOpen;
	self->mbFile->menu = self->menuFile;

#if USE_I2C_BRIDGE
	self->miLoad = TMenu_AddItem(self->menuFile, "Load...", 0, mFile_Open);
	self->miLoad->pic = get_pic16_fileopen(False);
	self->miSaveAs = TMenu_AddItem(self->menuFile, "Save As...", 0, mFile_SaveAs);
	self->miSaveAs->pic = get_pic16_filesave(False);
#endif
	TMenu_AddItem(self->menuFile, "-", 0, NULL);
	self->miLcdSaveAs = TMenu_AddItem(self->menuFile, "LCD Save As *.png", 0, mFile_LcdSaveAs);
	self->miLcdSaveAs->pic = get_pic16_filesave(False);
	TMenu_AddItem(self->menuFile, "-", 0, NULL);
	mi = TMenu_AddItem(self->menuFile, "Exit", 0, mFile_Exit);
	mi->pic = GetZIcon(zico16exit);
}
