/*
 Copyright (C) 2010-2015 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef __THEXFILEIO_H__
#define __THEXFILEIO_H__

typedef struct TSegment {
  struct TSegment *next;
  dword anf, end;
  byte *data;
} TSegment;

#define TCSelf THexFileIO
typedef struct THexFileIO {
  AlgTTC
  int debug;
  dword data_size;
  int hex_align;
  dword hex_align_anf;		//dsPIC33 0x00000000
  dword hex_align_end;		//dsPIC33 0x0007ffff
  char *FileName;
  TSegment *Seg0;
  dword max_adr;
  dword hadr;
  TLines *tl;
} THexFileIO;
#undef TCSelf

extern THexFileIO *THexFileIO_Create();
extern bool THexFileIO_LoadFromFile(THexFileIO *self, const char *FileName);

#endif /* __THEXFILEIO_H__ */
